/*
* ASIX FORTE LED blink example
* distributed as-is, without any warranties
* http://www.asix.net/
*
* version 1.0, Dec 2016
* 
*/

#include <stdio.h>
#include "forte.h"

void ReadStatus(char* message)
{
    int status = AGetBlocking();
    char* codestring = ReturnCodeString(status);
    if(message[0] != '\0') {
        printf("%s: %s\n", message, codestring);
    }
    else {
        printf("%s\n", codestring);
    }
}

int main(int argc, char *argv[])
{
    int prog_list[20];
    int prog_list_count;
    int i;
    
    printf("ASIX FORTE LED blink example \n");
   
    if(LoadForteDll("forte.dll") == FORTE_DLL_LOAD_OK) {
        printf("DLL load OK\n");
    }
    else {
        printf("DLL load FAILED\n");
        return 1;
    }
    
    AGetProgList(prog_list, 20, &prog_list_count);
    if(prog_list_count < 1) {
        printf("No Forte programmer found.\n");
        return 2;
    }
    for(i=0;i<prog_list_count;i++) {
        printf("Found S/N %06X\n", prog_list[i]);
    }
    
    QOpenProg(-1);
    ReadStatus("");
    
    QSetActiveLED(LED_ACT_Y_FAST_BLINK);
    ReadStatus("SetActiveLED");

    QDelay(2000000);
    ReadStatus("Delay");

    QSetActiveLED(LED_ACT_OFF);
    ReadStatus("SetActiveLED");

    QCheckGoButton();
    ReadStatus("");
    
    QCloseProg();
    ReadStatus("");
    
    return 0;
}

