/////////////////////////////////////////////////////////////////////////////
// Name:        device_96LC46B.h
// Purpose:     serial EEPROM 93LC46B
// Package:     ASIX FORTE programmer demo software
//              distributed as-is, without any warranties
// Author:      http://www.asix.net/
// Created:     2016
/////////////////////////////////////////////////////////////////////////////

#ifndef _DEVICE93LC46B_H
#define _DEVICE93LC46B_H

// ----------------------------------------------------------------------------
// headers
// ----------------------------------------------------------------------------

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

// for all others, include the necessary headers (this file is usually all you
// need because it includes almost all "standard" wxWidgets headers)
#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif

// header files
#include "device.h"

// ----------------------------------------------------------------------------
// class Device93LC46B
// ----------------------------------------------------------------------------

class Device93LC46B: public Device
{
public:
    // Constructor and destructor
    Device93LC46B();
    //variables
    //
    // functions
    virtual wxString GetName();
    virtual wxString GetShortHint();
    virtual wxString GetLongHint();
    virtual int GetMemoryWordSize(int memory_index);
    virtual int GetMemoryWordCount(int memory_index);
    virtual void RegisterActions();
    virtual void RegisterSettings();
    //
    void Read();
    void Write();
    void Verify();
    int ReadToBuffer(bool use_screen_buffer);
    unsigned char LsbToMsb(unsigned char databyte);
private:
    wxFloatProperty* prop_supply_rd;
    wxFloatProperty* prop_supply_wr;
    wxBoolProperty* prop_verify_write;
};

#endif /* _DEVICE93LC46B_H*/
