unit form;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    ButtonOpen: TButton;
    ButtonClose: TButton;
    ButtonAGet: TButton;
    LabelAGet: TLabel;
    EditVDD: TEdit;
    CheckVDD: TCheckBox;
    CheckLED: TCheckBox;
    CheckVPP: TCheckBox;
    EditVPP: TEdit;
    ButtonClearError: TButton;
    ButtonCheckVDD: TButton;
    ButtonCheckGoButton: TButton;
    LabelTranslation: TLabel;
    Panel1: TPanel;
    ComboD: TComboBox;
    ComboC: TComboBox;
    ComboI: TComboBox;
    ComboL: TComboBox;
    ComboP: TComboBox;
    ComboR: TComboBox;
    ComboS: TComboBox;
    ComboT: TComboBox;
    ButtonSetPins: TButton;
    ButtonGetPins: TButton;
    Panel2: TPanel;
    EditShift: TEdit;
    EditCount: TEdit;
    ButtonShiftByte: TButton;
    ButtonShiftByteOutIn: TButton;
    ButtonSetShiftSpeed: TButton;
    EditShiftSpeed: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    ButtonShiftByteIn: TButton;
    Button1Wire: TButton;
    CheckPullUp_L: TCheckBox;
    ButtonI2C: TButton;
    ButtonProgs: TButton;
    LabelProgs: TLabel;
    ButtonShiftBytes: TButton;
    ButtonAnI2C: TButton;
    ButtonAnStop: TButton;
    procedure ButtonOpenClick(Sender: TObject);
    procedure ButtonCloseClick(Sender: TObject);
    procedure ButtonAGetClick(Sender: TObject);
    procedure CheckVDDClick(Sender: TObject);
    procedure CheckLEDClick(Sender: TObject);
    procedure CheckVPPClick(Sender: TObject);
    procedure ButtonClearErrorClick(Sender: TObject);
    procedure ButtonCheckVDDClick(Sender: TObject);
    procedure ButtonCheckGoButtonClick(Sender: TObject);
    procedure ButtonSetPinsClick(Sender: TObject);
    procedure ButtonGetPinsClick(Sender: TObject);
    procedure ButtonShiftByteClick(Sender: TObject);
    procedure ButtonShiftByteOutInClick(Sender: TObject);
    procedure ButtonSetShiftSpeedClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ButtonShiftByteInClick(Sender: TObject);
    procedure Button1WireClick(Sender: TObject);
    procedure CheckPullUp_LClick(Sender: TObject);
    procedure ButtonI2CClick(Sender: TObject);
    procedure ButtonProgsClick(Sender: TObject);
    procedure ButtonShiftBytesClick(Sender: TObject);
    procedure ButtonAnI2CClick(Sender: TObject);
    procedure ButtonAnStopClick(Sender: TObject);
  private
    { Private declarations }
    Procedure ShowTranslation(code:integer);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
 COMMAND_MASK = $F0000;
 OPEN_OK = $10000;
 OPEN_NOTFOUND = $10001;
 OPEN_CANNOTOPEN = $10002;
 OPEN_ALREADYOPEN = $10003;
 OPEN_BADDRIVERVERSION = $10004;
 CLOSE_OK = $20000;
 CLOSE_CANNOTCLOSE = $20001;
 POWERON_OK = $30000;
 POWERON_OCURR = $30001;
 POWERON_WRONG_LEVEL = $30002; // the voltage level should be between 1V8 and 5V5
 GETPINS_CODE = $40000; { ored with GETPINS_PINx }
       GETPINS_PIND = $01;
       GETPINS_PINC = $02;
       GETPINS_PINI = $04;
       GETPINS_PINL = $08;
       GETPINS_PINP = $10;
       GETPINS_PINR = $20;
       GETPINS_PINS = $40;
       GETPINS_PINT = $80;
 OK = $50000;
 NOT_OPENED = $50001;
 WRONG_INPUT = $50002;
 AN_NOT_RUNNING = $50003;
 ERROR_AN_RUNNING = $50004;
 SHIFT_BYTE_OUTIN_CODE = $60000;
 SUPPLY_VOLTAGE_CODE = $70000;
 VPP_OK = $80000;
 VPP_OCURR = $80001;
 VPP_WRONG_LEVEL = $80002;
 GO_BUTTON_NOT_PRESSED=$90000;
 GO_BUTTON_PRESSED=$90001;
 SHIFT_BITS_OUTIN_CODE = $A0000;
 _1WIRE = $B0000;
 _1WIRE_PRESENT = $B0100;
 _1WIRE_NOT_PRESENT = $B0200;
 I2C_CODE  = $C0000;
 I2C_ACK   = $C0100;
 I2C_NACK  = $C0200;
 AN_DATA   = $D0000;   // Analyzer data
   AN_I2C_ACK      = $0100;
   AN_I2C_NACK     = $0200;
   AN_I2C_START    = $0400;
   AN_I2C_STOP     = $0800;
   AN_I2C_DATAMASK = $00FF;
// ---------------------------------
 FATAL_OVERCURRENTVDD = $01;
 FATAL_OVERCURRENTVPP = $02;
 FATAL_OVERVOLTAGEVDD = $04;
 FATAL_OTHER = $08;
// ---------------------------------
 PINS_HI = $3;
 PINS_LO = $2;
 PINS_HIZ = $1;
 PINS_D_BIT = $0;
 PINS_C_BIT = $2;
 PINS_I_BIT = $4;
 PINS_L_BIT = $6;
 PINS_P_BIT = $8;
 PINS_R_BIT = $A;
 PINS_S_BIT = $C;
 PINS_T_BIT = $E;

 PULLDOWN =   $1;
 PULLUP  =    $2;
 D_PULL =    $0;
 C_PULL =    $2;
 I_PULL =    $4;
 L_PULL =    $6;
 S_PULL =    $8;
 T_PULL =    $A;
 P_PULL =    $C;
 R_PULL =    $E;

 SHIFT_CLK_15000kHz=1;
 SHIFT_CLK_10000kHz=2;
 SHIFT_CLK_7500kHz=3;
 SHIFT_CLK_6000kHz=4;
 SHIFT_CLK_5000kHz=5;
 SHIFT_CLK_3750kHz=6;
 SHIFT_CLK_3330kHz=7;
 SHIFT_CLK_3000kHz=8;
 SHIFT_CLK_2500kHz=9;
 SHIFT_CLK_2000kHz=10;
 SHIFT_CLK_1500kHz=11;
 SHIFT_CLK_1000kHz=12;
 SHIFT_CLK_750kHz=13;
 SHIFT_CLK_600kHz=14;
 SHIFT_CLK_500kHz=15;
 SHIFT_CLK_400kHz=16;
 SHIFT_CLK_375kHz=17;
 SHIFT_CLK_333kHz=18;
 SHIFT_CLK_300kHz=19;
 SHIFT_CLK_250kHz=20;
 SHIFT_CLK_200kHz=21;
 SHIFT_CLK_150kHz=22;
 SHIFT_CLK_120kHz=23;
 SHIFT_CLK_100kHz=24;
 SHIFT_CLK_75kHz=25;
 SHIFT_CLK_60kHz=26;
 SHIFT_CLK_50kHz=27;
 SHIFT_CLK_40kHz=28;
 SHIFT_CLK_37kHz=29;
 SHIFT_CLK_33kHz=30;
 SHIFT_CLK_30kHz=31;

 SHIFT_OUTIN_PIND = $0;
 SHIFT_OUTIN_PINI = $2;
 SHIFT_OUTIN_PINL = $3;
 SHIFT_OUTIN_PINP = $4;
 SHIFT_OUTIN_PINR = $5;
 SHIFT_OUTIN_PINS = $6;
 SHIFT_OUTIN_PINT = $7;

 SHIFT_MODE0=$0;
 SHIFT_MODE1=$1;
 SHIFT_MODE2=$2;
 SHIFT_MODE3=$3;

 I2C_CLK_100kHz=0;
 I2C_CLK_400kHz=1;
 I2C_CLK_1MHz=2;

 LED_ACT_OFF           = 0;
 LED_ACT_Y             = 1;
 LED_ACT_R             = 2;
 LED_ACT_Y_BLINK       = 3;
 LED_ACT_R_BLINK       = 4;
 LED_ACT_Y_FAST_BLINK  = 5;
 LED_ACT_R_FAST_BLINK  = 6;
 LED_ACT_YR_FAST_BLINK = 7;
 // ---------------------------------

Procedure QOpenProg(sn: integer); stdcall; external 'forte.dll';
Procedure QCloseProg; stdcall; external 'forte.dll';
Procedure QSetActiveLED(led: integer); stdcall; external 'forte.dll';
Procedure QPoweronVdd(delayus: integer; Voltage_mV:integer); stdcall; external 'forte.dll';
Procedure QPoweroffVdd; stdcall; external 'forte.dll';
Procedure QPoweronVpp(Voltage_mV:integer); stdcall;  external 'forte.dll';
Procedure QPoweroffVpp; stdcall; external 'forte.dll';
Procedure QDelay(delayus: integer); stdcall; external 'forte.dll';
Procedure QDelay_ns(delayns: integer); stdcall; external 'forte.dll';
Procedure QSetPullUpDowns(pullupdowns: integer); stdcall; external 'forte.dll';
Procedure QCheckGoButton; stdcall; external 'forte.dll';
Procedure QCheckSupplyVoltage; stdcall; external 'forte.dll';
Procedure QSetGPIOAnswer(answer: LongBool); stdcall; external 'forte.dll';
Procedure QSetPins(pins: integer); stdcall; external 'forte.dll';
Procedure QGetPins; stdcall; external 'forte.dll';
Procedure QShiftByte(databyte:integer; mode:integer); stdcall; external 'forte.dll';
Procedure QShiftByte_OutIn(databyte:integer; mode:integer; InputPin:integer); stdcall; external 'forte.dll';
Procedure QShiftBytes(buf:pIntegerArray; mode:integer; count:integer); stdcall; external 'forte.dll';
Procedure QShiftBytes_OutIn(buf:pIntegerArray; mode:integer; InputPin:integer; count:integer); stdcall; external 'forte.dll';
Procedure QShiftBytes_In(mode:integer; InputPin:integer; count:integer); stdcall; external 'forte.dll';
Procedure QShiftBits(data:integer; mode:integer; bits_count:integer); stdcall; external 'forte.dll';
Procedure QShiftBits_OutIn(data: cardinal; mode:cardinal; InputPin:integer; bits_count:cardinal); stdcall; external 'forte.dll';
Procedure QSetShiftSpeed(speed:integer); stdcall; external 'forte.dll';
Procedure Q1WireInit; stdcall; external 'forte.dll';
Procedure Q1WireWriteByte(data:integer; strong_pullup_time_us:integer); stdcall; external 'forte.dll';
Procedure Q1WireReadByte; stdcall; external 'forte.dll';
Procedure QI2CStart(UseIntPullUps:LongBool); stdcall; external 'forte.dll';
Procedure QI2CStop; stdcall; external 'forte.dll';
Procedure QI2CWriteByte(databyte:integer); stdcall; external 'forte.dll';
Procedure QI2CReadByte(ACK:LongBool); stdcall; external 'forte.dll';
Procedure QI2CSetSpeed(speed:integer); stdcall; external 'forte.dll';
Procedure QAnI2CStart; stdcall; external 'forte.dll';
Procedure QAnStop; stdcall; external 'forte.dll';
Procedure AClearFatalError; stdcall; external 'forte.dll';
Function AGet(var answer: integer): LongBool; stdcall; external 'forte.dll';
Function AGetBlocking: Integer; stdcall; external 'forte.dll';
Function AGetBlock(buf: pIntegerArray; count:integer; var count_returned:integer): LongBool; stdcall;  external 'forte.dll';
Function AGetStatus(var NumberOfAnswers:integer): LongBool; stdcall; external 'forte.dll';
Procedure AGetProgList(buf: pIntegerArray; count:integer; var count_returned:integer); stdcall; external 'forte.dll';

Procedure TForm1.ShowTranslation(code:integer);
 begin
  // -------------
  if code=FATAL_OVERCURRENTVDD then LabelTranslation.Caption:='Overcurrent on VDD'
  else
  if code=FATAL_OVERCURRENTVPP then LabelTranslation.Caption:='Overcurrent on VPP'
  else
  if code=FATAL_OVERVOLTAGEVDD then LabelTranslation.Caption:='Overvoltage on VDD'
  else
  if code=FATAL_OTHER then LabelTranslation.Caption:='Other error'
  else
  // -------------
  if code and COMMAND_MASK = SUPPLY_VOLTAGE_CODE then
   LabelTranslation.Caption:='VDD: '+IntToStr((code and $FF) div 10)+'.'+IntToStr((code and $FF) mod 10)+' V'
  else
  if code and COMMAND_MASK = GETPINS_CODE then
   begin
    LabelTranslation.Caption:='Pins: ';
    LabelTranslation.Caption:=LabelTranslation.Caption+ 'D='+IntToStr(ord((code and GETPINS_PIND)<>0));
    LabelTranslation.Caption:=LabelTranslation.Caption+ ', C='+IntToStr(ord((code and GETPINS_PINC)<>0));
    LabelTranslation.Caption:=LabelTranslation.Caption+ ', I='+IntToStr(ord((code and GETPINS_PINI)<>0));
    LabelTranslation.Caption:=LabelTranslation.Caption+ ', L='+IntToStr(ord((code and GETPINS_PINL)<>0));
    LabelTranslation.Caption:=LabelTranslation.Caption+ ', P='+IntToStr(ord((code and GETPINS_PINP)<>0));
    LabelTranslation.Caption:=LabelTranslation.Caption+ ', R='+IntToStr(ord((code and GETPINS_PINR)<>0));
    LabelTranslation.Caption:=LabelTranslation.Caption+ ', S='+IntToStr(ord((code and GETPINS_PINS)<>0));
    LabelTranslation.Caption:=LabelTranslation.Caption+ ', T='+IntToStr(ord((code and GETPINS_PINT)<>0));
   end
  else
  if code and COMMAND_MASK =  SHIFT_BYTE_OUTIN_CODE then
   begin
    LabelTranslation.Caption:='ShiftByte in: 0x'+IntToHex((code and $FF),2);
   end
  else
  if (code and $FFF00)=_1WIRE then
   begin
    LabelTranslation.Caption:='1-Wire: 0x'+IntToHex((code and $FF),2);
   end
  else
  if (code and $FFF00)=I2C_CODE then
   begin
    LabelTranslation.Caption:='I2C: 0x'+IntToHex((code and $FF),2);
   end
  else
  if (code and COMMAND_MASK)=SHIFT_BITS_OUTIN_CODE then
   begin
    LabelTranslation.Caption:='SHIFT BITS: 0x'+IntToHex(code and $FFFF,2);
   end
  else
  if (code and COMMAND_MASK)=AN_DATA then
   begin
    if code=(AN_DATA or AN_I2C_ACK) then
     LabelTranslation.Caption:='ANALYZER I2C: ACK'
    else
    if code=(AN_DATA or AN_I2C_NACK) then
     LabelTranslation.Caption:='ANALYZER I2C: NACK'
    else
    if code=(AN_DATA or AN_I2C_START) then
     LabelTranslation.Caption:='ANALYZER I2C: START'
    else
    if code=(AN_DATA or AN_I2C_STOP) then
     LabelTranslation.Caption:='ANALYZER I2C: STOP'
    else
     LabelTranslation.Caption:='ANALYZER I2C: 0x'+IntToHex(code and AN_I2C_DATAMASK,2);
   end
  else
   begin
    case code of
     OPEN_OK: LabelTranslation.Caption:='Open: OK';
     OPEN_NOTFOUND: LabelTranslation.Caption:='Open: Programmer not found';
     OPEN_CANNOTOPEN: LabelTranslation.Caption:='Open: Cannot open programmer';
     OPEN_ALREADYOPEN: LabelTranslation.Caption:='Open: Programmer is already open.';
     OPEN_BADDRIVERVERSION:  LabelTranslation.Caption:='Open: FORTE requires at least version 2.08.14 of the USB driver.';
     CLOSE_OK: LabelTranslation.Caption:='Close: OK';
     POWERON_OK: LabelTranslation.Caption:='VDD ON: OK';
     POWERON_OCURR: LabelTranslation.Caption:='VDD ON: Overcurrent';
     POWERON_WRONG_LEVEL: LabelTranslation.Caption:='VDD ON: Wrong VDD level selected';
     OK: LabelTranslation.Caption:='OK';
     NOT_OPENED: LabelTranslation.Caption:='Programmer not opened';
     WRONG_INPUT: LabelTranslation.Caption:='Wrong input data';
     AN_NOT_RUNNING: LabelTranslation.Caption:='Analyzer not running';
     ERROR_AN_RUNNING: LabelTranslation.Caption:='Error, analyzer running';
     VPP_OK: LabelTranslation.Caption:='VPP ON: OK';
     VPP_OCURR: LabelTranslation.Caption:='VPP ON: Overcurrent';
     VPP_WRONG_LEVEL: LabelTranslation.Caption:='VPP ON: Wrong level';
     GO_BUTTON_NOT_PRESSED: LabelTranslation.Caption:='GO Button: Not pressed';
     GO_BUTTON_PRESSED: LabelTranslation.Caption:='GO Button: Pressed';
     _1WIRE_PRESENT: LabelTranslation.Caption:='1-Wire: Present';
     _1WIRE_NOT_PRESENT: LabelTranslation.Caption:='1-Wire: Not present';
     I2C_ACK: LabelTranslation.Caption:='I2C: ACK';
     I2C_NACK: LabelTranslation.Caption:='I2C: Not ACK';
     else     LabelTranslation.Caption:='';
    end;
   end;
 end;


procedure TForm1.ButtonOpenClick(Sender: TObject);
(*
 var
 PBuffer:PIntegerArray;
 progs: array [0..2] of cardinal;
 count:integer;
*)
begin
 QOpenProg(-1);
// QOpenProg($A6040003);

(*
 // check the available programmers and open the first sn returned
 // ----------
 PBuffer:=@progs;
 AGetProgList(PBuffer,6,count);

 if count>0 then
  begin
   QOpenProg(PBuffer[0]);
   LabelProgs.Caption:='Open prog sn: '+IntToHex(progs[0],6);
  end;
 // ----------
*)
end;

procedure TForm1.ButtonSetPinsClick(Sender: TObject);
 var value:integer;
begin
 value:=ComboD.ItemIndex+1 shl PINS_D_BIT;
 value:= value or ((ComboC.ItemIndex+1) shl PINS_C_BIT);
 value:= value or ((ComboI.ItemIndex+1) shl PINS_I_BIT);
 value:= value or ((ComboL.ItemIndex+1) shl PINS_L_BIT);
 value:= value or ((ComboP.ItemIndex+1) shl PINS_P_BIT);
 value:= value or ((ComboR.ItemIndex+1) shl PINS_R_BIT);
 value:= value or ((ComboS.ItemIndex+1) shl PINS_S_BIT);
 value:= value or ((ComboT.ItemIndex+1) shl PINS_T_BIT);
 QSetPins(value);
end;

procedure TForm1.ButtonSetShiftSpeedClick(Sender: TObject);
begin
 QSetShiftSpeed(StrToInt(EditShiftSpeed.Text));
end;

procedure TForm1.ButtonShiftByteClick(Sender: TObject);
begin
 QShiftByte(StrToInt(EditShift.Text), StrToInt(EditCount.Text));
end;

procedure TForm1.ButtonShiftByteInClick(Sender: TObject);
begin
 // mode, inputpin, count
 QShiftBytes_In(0, SHIFT_OUTIN_PINI, 1);
end;

procedure TForm1.ButtonShiftByteOutInClick(Sender: TObject);
begin
 QShiftByte_OutIn(StrToInt(EditShift.Text), StrToInt(EditCount.Text), SHIFT_OUTIN_PINI);
end;

procedure TForm1.ButtonShiftBytesClick(Sender: TObject);
var buf: array [0..255] of integer;
    i:integer;
    Pbuf:PIntegerArray;
begin
 Pbuf:=@buf;

 // fill the array with random data
 Randomize;

 for i := 0 to 255 do
  buf[i]:=Random($100);

 // shift 256 Bytes in SPI mode 0
 QShiftBytes(Pbuf, SHIFT_MODE0, 256);

// // shift data out and read on the I pin
// QShiftBytes_OutIn(Pbuf, SHIFT_MODE0, SHIFT_OUTIN_PINI, 256);
end;

procedure TForm1.CheckLEDClick(Sender: TObject);
begin
 if CheckLED.Checked then
  // red LED is on
  QSetActiveLED(2)
 else
  // LED is off
  QSetActiveLED(0);
end;

procedure TForm1.CheckPullUp_LClick(Sender: TObject);
begin
 if CheckPullUp_L.Checked then
  QSetPullUpDowns(PULLUP shl L_PULL)
 else
  QSetPullUpDowns(0);
end;

procedure TForm1.CheckVDDClick(Sender: TObject);
begin
 if CheckVDD.Checked then
  // switch Vdd on, delay 100ms
  QPoweronVdd(100000, StrToInt(EditVDD.Text))
 else
  // switch Vdd off
  QPowerOffVdd;
end;


procedure TForm1.CheckVPPClick(Sender: TObject);
begin
 if CheckVPP.Checked then
  QPoweronVpp(StrToInt(EditVPP.Text))
 else
  QPoweroffVpp;
end;

procedure TForm1.ButtonClearErrorClick(Sender: TObject);
begin
 AClearFatalError;
end;

procedure TForm1.ButtonCloseClick(Sender: TObject);
begin
 QCloseProg;
end;

procedure TForm1.ButtonGetPinsClick(Sender: TObject);
begin
 QGetPins;
end;

procedure TForm1.ButtonI2CClick(Sender: TObject);
var buf: array [0..255] of integer;
    data,i,j:integer;
    Pbuf:PIntegerArray;
begin
 // --------------
 // read 24LC02B I2C memory
 // it is 2kBit=256Bytes memory
 // it supposes that the supply voltage is already on
 // --------------

 Pbuf:=@buf;

 ButtonI2C.Enabled:=false;

 // if there are some results, user did not read, I will read them now, up to 100 values
 AGetBlock(Pbuf, 100, data);


 // set communication frequency to 400kHz
 QI2CSetSpeed(I2C_CLK_400kHz);
 AGetBlocking;

 // I2CStart, use internal pull-ups
 QI2CStart(true);
 // write command
 QI2CWriteByte($A0);
 // address
 QI2CWriteByte($00);


 // address is set, now read
 QI2CStart(true);

 // read command
 QI2CWriteByte($A1);

 // read the results of the functions
 // --------------
 // wait for the results
 data:=0;
 while data<5 do
  if not AGetStatus(data) then
   begin
    LabelTranslation.Caption:='ReadI2C: HW Error';
    ButtonI2C.Enabled:=true;
    exit;
   end;

 // read the results
 AGetBlock(Pbuf, 5, data);
 if (buf[0]<>OK) or (buf[1]<>I2C_ACK) or (buf[2]<>I2C_ACK) or (buf[3]<>OK) or (buf[4]<>I2C_ACK) then
  begin
   LabelTranslation.Caption:='ReadI2C: Communication error';
   ButtonI2C.Enabled:=true;
   exit;
  end;
 // --------------
 // read the 256bytes of the memory
 i:=0;
 j:=0;
 while (i<256) or (j<256) do
  begin
   if i<256 then
    begin

     // the last byte should be read with NACK
     if i=255 then
      begin
       QI2CReadByte(false);
       // stop bit
       QI2CStop;
      end
     else
      QI2CReadByte(true);

     Inc(i,1);
    end;

   // read the returned data
   if not AGetStatus(data) then
    begin
     LabelTranslation.Caption:='ReadI2C: HW Error';
     ButtonI2C.Enabled:=true;
     exit;
    end;

    // I want to show the first 5 read values, so I wait for them to get them together
    if (j=0) and (data<5) then Continue;


   if (j<256) and (data>0) then
    begin

     if data>256-j then
      data:=256-j;

     AGetBlock(Pbuf, data, data);

     // I will show the first 5 values
     if j=0 then LabelTranslation.Caption:=IntToHex((buf[0] and $FF),2)+','+IntToHex((buf[1] and $FF),2)+','+IntToHex((buf[2] and $FF),2)+','+IntToHex((buf[3] and $FF),2)+','+IntToHex((buf[4] and $FF),2)+',...';

     // here I could save the data somewhere and then to work with them...
     Inc(j,data);
    end;
  end;

 // wait for the result of the QI2CStop
 AGetBlocking;
 ButtonI2C.Enabled:=true;
end;

procedure TForm1.ButtonCheckGoButtonClick(Sender: TObject);
begin
 QCheckGoButton;
end;

procedure TForm1.ButtonCheckVDDClick(Sender: TObject);
begin
 QCheckSupplyVoltage;
end;

procedure TForm1.Button1Click(Sender: TObject);

var i, j:integer;
    data:integer;
    buf: array [0..16383] of integer;
    Pbuf:PIntegerArray;
    RetNumber:integer;

Function RevHex(data:byte):byte; // makes a reversed HEX byte, bit0->bit7,...
 var i:byte;
 begin
  Result:=0;
  for i:=0 to 7 do
   if data and ($1 shl i)<>0 then
    Result:=Result or ($80 shr i);
 end;

begin

 // ***********************
 // read flash M25P80
 // ***********************
 Pbuf:=@buf;

 Button1.Enabled:=false;

 // red LED slowly blinking
 QSetActiveLED(4);

 // 10MHz
 QSetShiftSpeed(SHIFT_CLK_10000kHz);

 // switch off the answer of the output GPIO functions and delay
 QSetGPIOAnswer(false);

 // wait for results of the previous functions
 for i:=0 to 2 do
  begin
   data:=AGetBlocking;
   // if the result is an error of HW, exit
   if data and COMMAND_MASK=0 then
    begin
     LabelAGet.Caption:='Read flash: HW Error';
     Button1.Enabled:=true;
     exit;
    end;

   if data=NOT_OPENED then
    begin
     LabelAGet.Caption:='Error: programmer not opened';
     Button1.Enabled:=true;
     exit;
    end;
  end;


 // CS(P) ->1
 // C->0
 // D->0
 QSetPins((PINS_HI shl PINS_P_BIT)or (PINS_LO shl PINS_C_BIT)or (PINS_LO shl PINS_D_BIT));
 QDelay(10000);

 // read flash M25P80, SPI mode 0
 // CS(P) ->0
 QSetPins(PINS_LO shl PINS_P_BIT);
 QDelay(1);

 // read command 0x03, as LSB first must be $C0
 QShiftByte($C0, 0);
 // send address, 3bytes
 QShiftByte(0, 0);
 QShiftByte(0, 0);
 QShiftByte(0, 0);

 i:=0;
 j:=0;
 // the memory we read has 0x100000 Bytes (8Mbit)
 while (i<$100000) or (j<$100000) do
  begin

   // here I read the data
   if (i<$100000) then
    begin


     if i+512<$100000 then
      begin
       QShiftBytes_In(0, SHIFT_OUTIN_PINI, 512);
       inc(i,512);
      end
     else
      begin
       QShiftBytes_In(0, SHIFT_OUTIN_PINI, $100000-i);
       i:=$100000;
      end

    end;

   // here I wait for returned read data
   if (j<$100000) then
    begin
     if AGetStatus(RetNumber) then
      begin

       // I will wait until I have enough data to be able to display them
       if (j=0) and (RetNumber<7) then continue;


       if RetNumber>0 then
        begin
         // I can maximally read 16384 integers, because of the size of the array
         if RetNumber>16384 then RetNumber:=16384;
         AGetBlock(Pbuf, RetNumber,RetNumber);

         // here I have RetNumber of Integers read from the memory in the buf array

         // display first several bytes, their bits are reversed, because FORTE reads LSB first, but the memory sends MSB first
         if j=0 then
          begin
           LabelAGet.Caption:=IntToHex(RevHex(buf[0] and $FF),2)+', '+IntToHex(RevHex(buf[1] and $FF),2)+', '+IntToHex(RevHex(buf[2] and $FF),2)+', '+IntToHex(RevHex(buf[3] and $FF),2)+', '+IntToHex(RevHex(buf[4] and $FF),2)+', '+IntToHex(RevHex(buf[5] and $FF),2)+', '+IntToHex(RevHex(buf[6] and $FF),2)+', ...';
          end;

         inc(j, RetNumber);
        end;
      end
     else
      begin
       // when AGetStatus returns false, there is a fatal error
       LabelAGet.Caption:='Read flash: HW Error';
       Button1.Enabled:=true;
       exit;
      end;
    end;
  end;

 // CS(P)->1
 QSetPins((PINS_HI shl PINS_P_BIT)or (PINS_LO shl PINS_C_BIT)or (PINS_LO shl PINS_D_BIT));
 QDelay(1000);
 // yellow LED on
 QSetActiveLED(1);
 AGetBlocking;
 // enable the GPIO answer
 QSetGPIOAnswer(true);
 AGetBlocking;

 Button1.Enabled:=true;
end;


procedure TForm1.Button1WireClick(Sender: TObject);
var data: integer;
    buf: array [0..99] of integer;
    Pbuf: PIntegerArray;
begin

 // ***********************
 // supposes DS18B20 on P pin and a 5k pullup to VDD of the programmer
 // the programmer must be open and the supply voltage must be on
 //
 // measures temperature and reads the measured value
 // ***********************

 Button1Wire.Enabled:=false;

 Pbuf:=@buf;

 // if there are some results, user did not read, I will read them now, up to 100 values
 AGetBlock(Pbuf, 100, data);

 // switch off the answer of the output GPIO functions and delay
 QSetGPIOAnswer(false);

 // read result of the QSetGPIOAnswer
 if AGetBlocking <> OK then
  begin
   LabelAGet.Caption:='1Wire: ERROR, programmer not open.';
   Button1Wire.Enabled:=true;
   exit;
  end;

 // measure temperature
 // ---------
 Q1WireInit;
 // skip ROM command
 Q1WireWriteByte($CC, 0);
 // convert T command, with strong pull-up for 750ms, which is the conversion time
 Q1WireWriteByte($44, 750000);

 // read the measured value
 // ---------
 Q1WireInit;
 // skip ROM command
 Q1WireWriteByte($CC, 0);
 // read scratchpad, read only the two first bytes, which is the temperature
 Q1WireWriteByte($BE, 0);
 Q1WireReadByte;
 Q1WireReadByte;


 // get results of the two inits
 data:=0;
 while AGetStatus(data) and (data<2)do;

 if data=0 then
  begin
   LabelAGet.Caption:='1Wire: Fatal error.';
   Button1Wire.Enabled:=true;
   exit;
  end;

 AGetBlock(Pbuf, 2, data);

 if (buf[0]<>_1WIRE_PRESENT) or (buf[1]<>_1WIRE_PRESENT) then
  begin
   LabelAGet.Caption:='1Wire: ERROR, device not present.';
   Button1Wire.Enabled:=true;
   // enable the GPIO answer
   QSetGPIOAnswer(true);
   AGetBlocking;
   exit;
  end;


 // get the measured data
 data:=AGetBlocking and $FF;
 data:=data or ((AGetBlocking and $FF) shl 8);


 // if the result is negative, we will count the absolut value
 if (data and $F800)>0 then
  begin
   data:=((not data)+1) and $FFFF;

   // we do not care for decimal positions
   data:=data shr 4;

   // we do not want a negative zero
   if data=0 then
    LabelAGet.Caption:='DS18B20, temperature: '+IntToStr(data)+' degrees C'
   else
    LabelAGet.Caption:='DS18B20, temperature: -'+IntToStr(data)+' degrees C';
  end
 else // positive temperature
  begin
   // we do not care for decimal positions
   data:=data shr 4;

   LabelAGet.Caption:='DS18B20, temperature: '+IntToStr(data)+' degrees C';
  end;


 // enable the GPIO answer
 QSetGPIOAnswer(true);
 AGetBlocking;

 Button1Wire.Enabled:=true;
end;

procedure TForm1.ButtonProgsClick(Sender: TObject);
 var
 i:integer;
 PBuffer:PIntegerArray;
 progs: array [0..5] of cardinal;
 count:integer;
begin
 PBuffer:=@progs;
 AGetProgList(PBuffer,6,count);

 LabelProgs.Caption:=IntToStr(count);

 if count>0 then
  for i := 0 to count-1 do
   LabelProgs.Caption:=LabelProgs.Caption+', '+IntToHex(progs[i],6);
end;


procedure TForm1.ButtonAGetClick(Sender: TObject);
var value:integer;
begin
 if AGet(value) then
  begin
   LabelAGet.Caption:='Returned value: '+IntToHex(value,4);
   ShowTranslation(value);
  end
 else
  begin
   LabelAGet.Caption:='Returned value: ';
   ShowTranslation(-1);
  end;
end;

procedure TForm1.ButtonAnI2CClick(Sender: TObject);
begin
 QAnI2CStart;
end;

procedure TForm1.ButtonAnStopClick(Sender: TObject);
begin
 QAnStop;
end;

end.
